unit Unit2;

interface

uses
 k3ks_texttools,
 SysUtils,
 IdHTTP,
 Classes;

type
  THTTPGetThread = class(TThread)
  private
    { Private declarations }
    FGC:TIdHTTP;
    FState: integer;
    FIPAddr: string;
    FError: integer;
    FCommands: string;
    FLogs: TK3KSTextVarArray;
    FID: integer;
    procedure SetIPAddr(const Value: string);
    procedure SetState(const Value: integer);
    procedure SetError(const Value: integer);
    procedure SendAndReceive;
    function CheckTerminated:boolean;
    procedure SetCommands(const Value: string);
    procedure SetID(const Value: integer);
  protected
    procedure Execute; override;
  public
    property ID:integer read FID write SetID;
    property IPAddr:string read FIPAddr write SetIPAddr;
    property Commands:string read FCommands write SetCommands;
    property State:integer read FState;
    property Error:integer read FError;
    property Logs:TK3KSTextVarArray read FLogs;
  end;

implementation

uses Math;

{ Important: Methods and properties of objects in visual components can only be
  used in a method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure THTTPGetThread.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

{ THTTPGetThread }

function THTTPGetThread.CheckTerminated: boolean;
begin
 Result:=Terminated;
 if Result then FError:=10;
end;

procedure THTTPGetThread.Execute;
begin
 { Place thread code here }
 try
  FLogs:=nil;
  if CheckTerminated then Exit;
  try
  FGC:=TIdHTTP.Create(nil);
   try
    FError:=0;FState:=1;
    if not CheckTerminated then SendAndReceive;
   finally
    FGC.Free;
   end;
  except
   FError:=1;
  end;
 finally
  FState:=-1;
  Terminate;
 end;
end;

procedure THTTPGetThread.SendAndReceive;
var
 Buffer:array[0..2049] of char;
 src,SL:TStringList;
 cnt,i:integer;
 sResult,s:string;
 va:TK3KSTextVarArray;
 mode:integer;
 postdata,addr:string;
begin
 FLogs:=nil;
 SL:=TStringList.Create;
 src:=TStringList.Create;
 try
  SL.Text:=Commands;
  with FGC do begin
   try
    for i:=0 to SL.Count-1 do begin
     SplitStringToTextVA(SL[i],' ','"',va);
     if Length(va)=0 then Continue;
     if Length(va)<2 then FError:=10 else begin
      mode:=0;
      if AnsiCompareText(va[0],'get')=0 then mode:=1;
      if AnsiCompareText(va[0],'post')=0 then mode:=2;
      if mode=0 then FError:=18 else begin
       addr:=va[1];
       if (mode=2) then begin
        if (Length(va)<=2) then FError:=111 else begin
         postdata:=va[2];
         SplitString(postdata,'&',#0,src);
        end; 
       end;
      end;
     end;
     if (FError=0) then begin
      case mode of
       1: s:=Get(FIPAddr+addr);
       2: s:=Post(FIPAddr+addr,src);
      end;
      AddVarToTextVA(FLogs,s);
      s:=AnsiUpperCase(s);
      if (pos('<HTML',s)=0) or (pos('</HTML',s)=0) then FError:=5;
     end;
    end;
   except
    FError:=3;
   end;
   if (FError<>0) then
    AddVarToTextVA(FLogs,'An error occured. The error code is: '+IntToStr(FError));
  end;
 finally
  SL.Free;
  src.Free;
 end;
end;

procedure THTTPGetThread.SetCommands(const Value: string);
begin
  FCommands := Value;
end;

procedure THTTPGetThread.SetError(const Value: integer);
begin
 FError := Value;
end;

procedure THTTPGetThread.SetID(const Value: integer);
begin
  FID := Value;
end;

procedure THTTPGetThread.SetIPAddr(const Value: string);
begin
  FIPAddr := Value;
end;

procedure THTTPGetThread.SetState(const Value: integer);
begin
 FState := Value;
end;

end.
